# PCollection Class Reference

A collection is a container that collects together descendents of the `PObject` class. More...

`#include <contain.h>`

Inheritance diagram for PCollection:

List of all members.

## Public Member Functions

Construction
| PCollection (PINDEX initialSize=0)
| Create a new collection.
Overrides from class PObject
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream.
Common functions for collections
virtual PINDEX | Append (PObject *obj)=0
| Append a new object to the collection.
virtual PINDEX | Insert (const PObject &before, PObject *obj)=0
| Insert a new object immediately before the specified object.
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)=0
| Insert a new object at the specified ordinal index.
virtual PBoolean | Remove (const PObject *obj)=0
| Remove the object from the collection.
virtual PObject * | RemoveAt (PINDEX index)=0
| Remove the object at the specified ordinal index from the collection.
virtual void | RemoveAll ()
| Remove all of the elements in the collection.
virtual PBoolean | SetAt (PINDEX index, PObject *val)=0
| Set the object at the specified ordinal position to the new value.
virtual PObject * | GetAt (PINDEX index) const =0
| Get the object at the specified ordinal position.
virtual PINDEX | GetObjectsIndex (const PObject *obj) const =0
| Search the collection for the specific instance of the object.
virtual PINDEX | GetValuesIndex (const PObject &obj) const =0
| Search the collection for the specified value of the object.
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection.
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection.

## Protected Member Functions

PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function.

## Detailed Description

A collection is a container that collects together descendents of the `PObject` class.

The objects contained in the collection are always pointers to objects, not the objects themselves. The life of an object in the collection should be carefully considered. Typically, it is allocated by the user of the collection when it is added. The collection then automatically deletes it when it is removed or the collection is destroyed, ie when the container class has no more references to the collection. Other models may be accommodated but it is up to the programmer to determine the scope and life of the objects.

The exact form of the collection depends on the descendent of PCollection and determines the access modes for the objects in it. Thus a collection can be an array which allows fast random access at the expense of slow insertion and deletion. Or the collection may be a list which has fast insertion and deletion but very slow random access.

The basic paradigm of all collections is the "virtual array". Regardless of the internal implementation of the collection; array, list, sorted list etc, the user may access elements via an ordinal index. The implementation then optimises the access as best it can. For instance, in a list ordinal zero will go directly to the head of the list. Stepping along sequential indexes then will return the next element of the list, remembering the new position at each step, thus allowing sequential access with little overhead as is expected for lists. If a random location is specified, then the list implementation must sequentially search for that ordinal from either the last location or an end of the list, incurring an overhead.

All collection classes implement a base set of functions, though they may be meaningless or degenerative in some collection types eg `Insert()` for `PSortedList` will degenerate to be the same as `Append()`.

## Constructor & Destructor Documentation

PCollection::PCollection | ( | PINDEX | initialSize = `0` | ) |

Create a new collection.

Parameters:

  initialSize | Initial number of things in the collection.

PINLINE PCollection::PCollection | ( | int | dummy,
|  | const PCollection * | coll |
| ) |  |  | `[protected]`

Constructor used in support of the Clone() function.

This creates a new unique reference of a copy of the contents. It does {not} create another reference.

The dummy parameter is there to prevent the contructor from being invoked automatically by the compiler when a pointer is used by accident when a normal instance or reference was expected. The container would be silently cloned and the copy used instead of the container expected leading to unpredictable results.

Parameters:

  dummy | Dummy to prevent accidental use of the constructor.
  coll | Collection class to clone.

## Member Function Documentation

PINLINE void PCollection::AllowDeleteObjects | ( | PBoolean | yes = `true` | ) |

Allow or disallow the deletion of the objects contained in the collection.

If true then whenever an object is removed, overwritten or the colelction is deleted due to all references being destroyed, the object is deleted.

For example:

                  coll.SetAt(2, new PString("one"));
                  coll.SetAt(2, new PString("Two"));

would automatically delete the string containing "one" on the second call to SetAt().

Parameters:

  yes | New value for flag for deleting objects

virtual PINDEX PCollection::Append | ( | PObject * | obj | ) | `[pure virtual]`

Append a new object to the collection.

The exact semantics depends on the specific type of the collection. So the function may not place the object at the "end" of the collection at all. For example, in a `PSortedList` the object is placed in the correct ordinal position in the list.

Returns:
  index of the newly added object.

Parameters:

  obj | New object to place into the collection.

Implemented in PArrayObjects, PAbstractSet, PAbstractList, and PAbstractSortedList.

void PCollection::DisallowDeleteObjects | ( |  | ) |

Disallow the deletion of the objects contained in the collection.

See the `AllowDeleteObjects()` function for more details.

virtual PObject* PCollection::GetAt | ( | PINDEX | index | ) | const`[pure virtual]`

Get the object at the specified ordinal position.

If the index was greater than the size of the collection then NULL is returned.

Returns:
  pointer to object at the specified index.

Parameters:

  index | Index position in the collection of the object.

Implemented in PArrayObjects, PAbstractSet, PAbstractDictionary, PAbstractList, and PAbstractSortedList.

virtual PINDEX PCollection::GetObjectsIndex | ( | const PObject * | obj | ) | const`[pure virtual]`

Search the collection for the specific instance of the object.

The object pointers are compared, not the values. The fastest search algorithm is employed depending on the collection type.

Returns:
  ordinal index position of the object, or P_MAX_INDEX.

Parameters:

  obj | Object to search for.

Implemented in PArrayObjects, PAbstractSet, PAbstractDictionary, PAbstractList, and PAbstractSortedList.

virtual PINDEX PCollection::GetValuesIndex | ( | const PObject & | obj | ) | const`[pure virtual]`

Search the collection for the specified value of the object.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The fastest search algorithm is employed depending on the collection type.

Returns:
  ordinal index position of the object, or P_MAX_INDEX.

Parameters:

  obj | Object to search for.

Implemented in PArrayObjects, PAbstractSet, PAbstractDictionary, PAbstractList, and PAbstractSortedList.

virtual PINDEX PCollection::Insert | ( | const PObject & | before,
|  | PObject * | obj |
| ) |  |  | `[pure virtual]`

Insert a new object immediately before the specified object.

If the object to insert before is not in the collection then the equivalent of the `Append()` function is performed.

The exact semantics depends on the specific type of the collection. So the function may not place the object before the specified object at all. For example, in a `PSortedList` the object is placed in the correct ordinal position in the list.

Note that the object values are compared for the search of the `before` parameter, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function.

Returns:
  index of the newly inserted object.

Parameters:

  before | Object value to insert before.
  obj | New object to place into the collection.

Implemented in PArrayObjects, PAbstractSet, PAbstractDictionary, PAbstractList, and PAbstractSortedList.

virtual PINDEX PCollection::InsertAt | ( | PINDEX | index,
|  | PObject * | obj |
| ) |  |  | `[pure virtual]`

Insert a new object at the specified ordinal index.

If the index is greater than the number of objects in the collection then the equivalent of the `Append()` function is performed.

The exact semantics depends on the specific type of the collection. So the function may not place the object at the specified index at all. For example, in a `PSortedList` the object is placed in the correct ordinal position in the list.

Returns:
  index of the newly inserted object.

Parameters:

  index | Index position in collection to place the object.
  obj | New object to place into the collection.

Implemented in PArrayObjects, PAbstractSet, PAbstractDictionary, PAbstractList, and PAbstractSortedList.

virtual void PCollection::PrintOn | ( | ostream & | strm | ) | const`[virtual]`

Print the collection on the stream.

This simply executes the `PObject::PrintOn()` function on each element in the collection.

The default behaviour for collections is to print each element separated by the stream fill character. Note that if the fill character is the default ' ' then no separator is printed at all.

Also if the fill character is not ' ', the the streams width parameter is set before each individual element of the colllection.

Returns:
  the stream printed to.

Parameters:

  strm | Output stream to print the collection.

Reimplemented from PObject.

Reimplemented in PAbstractDictionary, PMIMEInfo, PvCard::ParamValues, PvCard::TypeValues, and PvCard::TextValues.

virtual PBoolean PCollection::Remove | ( | const PObject * | obj | ) | `[pure virtual]`

Remove the object from the collection.

If the AllowDeleteObjects option is set then the object is also deleted.

Note that the comparison for searching for the object in collection is made by pointer, not by value. Thus the parameter must point to the same instance of the object that is in the collection.

Returns:
  true if the object was in the collection.

Parameters:

  obj | Existing object to remove from the collection.

Implemented in PArrayObjects, PAbstractSet, PAbstractList, and PAbstractSortedList.

virtual void PCollection::RemoveAll | ( |  | ) | `[virtual]`

Remove all of the elements in the collection.

This operates by continually calling `RemoveAt()` until there are no objects left.

The objects are removed from the last, at index `(GetSize()-1)` toward the first at index zero.

Reimplemented in PArrayObjects, and PAbstractSortedList.

virtual PObject* PCollection::RemoveAt | ( | PINDEX | index | ) | `[pure virtual]`

Remove the object at the specified ordinal index from the collection.

If the AllowDeleteObjects option is set then the object is also deleted.

Note if the index is beyond the size of the collection then the function will assert.

Returns:
  pointer to the object being removed, or NULL if it was deleted.

Parameters:

  index | Index position in collection to place the object.

Implemented in PArrayObjects, PAbstractSet, PAbstractDictionary, PAbstractList, and PAbstractSortedList.

virtual PBoolean PCollection::SetAt | ( | PINDEX | index,
|  | PObject * | val |
| ) |  |  | `[pure virtual]`

Set the object at the specified ordinal position to the new value.

This will overwrite the existing entry. If the AllowDeleteObjects option is set then the old object is also deleted.

The exact semantics depends on the specific type of the collection. For some, eg `PSortedList`, the object inserted will not stay at the ordinal position. Also the exact behaviour when the index is greater than the size of the collection depends on the collection type, eg in an array collection the array is expanded to accommodate the new index, whereas in a list it will return false.

Returns:
  true if the object was successfully added.

Parameters:

  index | Index position in collection to set.
  val | New value to place into the collection.

Implemented in PArrayObjects, PAbstractSet, PAbstractDictionary, PAbstractList, and PAbstractSortedList.

The documentation for this class was generated from the following file:

- contain.h